package mod.mcreator;

import net.minecraft.world.biome.BiomeGenBase;
import net.minecraft.world.World;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.DamageSource;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.init.Items;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.monster.EntityMob;
import net.minecraft.entity.effect.EntityLightningBolt;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAINearestAttackableTarget;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAILeapAtTarget;
import net.minecraft.entity.ai.EntityAIHurtByTarget;
import net.minecraft.entity.ai.EntityAIAttackOnCollide;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.EntityList;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.entity.RenderBiped;
import net.minecraft.client.model.ModelBiped;

import java.util.Random;

import cpw.mods.fml.relauncher.SideOnly;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.common.registry.EntityRegistry;
import cpw.mods.fml.common.event.FMLServerStartingEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.client.registry.RenderingRegistry;

@SuppressWarnings("unchecked")
public class mcreator_bloodyZombiePigman {

	public static int mobid = 0;
	public Object instance;

	public void load() {
	}

	public void generateNether(World world, Random random, int chunkX, int chunkZ) {
	}

	public void generateSurface(World world, Random random, int chunkX, int chunkZ) {
	}

	public int addFuel(ItemStack fuel) {
		return 0;
	}

	@SideOnly(Side.CLIENT)
	public void registerRenderers() {
		RenderingRegistry.registerEntityRenderingHandler(mcreator_bloodyZombiePigman.EntitybloodyZombiePigman.class, new RenderBiped(
				new ModelBiped(), 0) {
			protected ResourceLocation getEntityTexture(Entity par1Entity) {
				return new ResourceLocation("bloody_pigman.png");
			}
		});

	}

	public void serverLoad(FMLServerStartingEvent event) {
	}

	public void preInit(FMLPreInitializationEvent event) {
		int entityID = EntityRegistry.findGlobalUniqueEntityId();
		mobid = entityID;
		EntityRegistry.registerGlobalEntityID(mcreator_bloodyZombiePigman.EntitybloodyZombiePigman.class, "bloodyZombiePigman", entityID);
		EntityRegistry.registerModEntity(mcreator_bloodyZombiePigman.EntitybloodyZombiePigman.class, "bloodyZombiePigman", entityID, instance, 64, 1,
				true);
		EntityList.entityEggs.put(Integer.valueOf(entityID), new EntityList.EntityEggInfo(entityID, (204 << 16) + (0 << 8) + 0, (255 << 16)
				+ (204 << 8) + 204));
		EntityRegistry.addSpawn(mcreator_bloodyZombiePigman.EntitybloodyZombiePigman.class, 20, 3, 30, EnumCreatureType.monster, BiomeGenBase.hell);

	}

	/*
	 * public Entity spawnEntity(int var1, World var2, double var3, double var5,
	 * double var7) { if(var1==mobid) return new
	 * mcreator_bloodyZombiePigman.EntitybloodyZombiePigman(var2); else return
	 * null; }
	 */

	public static class EntitybloodyZombiePigman extends EntityMob {
		World world = null;

		public EntitybloodyZombiePigman(World var1) {
			super(var1);
			world = var1;
			experienceValue = 5;
			this.isImmuneToFire = false;
			addRandomArmor();
			this.tasks.addTask(0, new EntityAISwimming(this));
			this.tasks.addTask(6, new EntityAIWander(this, 1.0D));
			this.tasks.addTask(8, new EntityAILookIdle(this));
			this.targetTasks.addTask(10, new EntityAINearestAttackableTarget(this, EntityPlayer.class, 2, true));
			this.targetTasks.addTask(11, new EntityAIHurtByTarget(this, false));
			this.tasks.addTask(10, new EntityAISwimming(this));
			this.tasks.addTask(10, new EntityAIAttackOnCollide(this, EntityPlayer.class, 1.0D, false));
			this.tasks.addTask(10, new EntityAILeapAtTarget(this, 0.8F));

		}

		protected void applyEntityAttributes() {
			super.applyEntityAttributes();
			this.getEntityAttribute(SharedMonsterAttributes.movementSpeed).setBaseValue(0.35D);
			this.getEntityAttribute(SharedMonsterAttributes.maxHealth).setBaseValue(20D);
			if (this.getEntityAttribute(SharedMonsterAttributes.attackDamage) != null)
				this.getEntityAttribute(SharedMonsterAttributes.attackDamage).setBaseValue(6D);
		}

		protected void addRandomArmor() {

			this.setCurrentItemOrArmor(0, new ItemStack(Items.golden_sword));
		}

		protected void dropRareDrop(int par1) {
			this.dropItem(Items.golden_sword, 1);
		}

		public boolean isAIEnabled() {
			return true;
		}

		@Override
		protected Item getDropItem() {
			return new ItemStack(Items.gold_ingot).getItem();
		}

		/**
		 * Returns the sound this mob makes while it's alive.
		 */
		protected String getLivingSound() {
			return "mob.zombiepig.zpig";
		}

		/**
		 * Returns the sound this mob makes when it is hurt.
		 */
		protected String getHurtSound() {
			return "mob.zombiepig.zpighurt";
		}

		/**
		 * Returns the sound this mob makes on death.
		 */
		protected String getDeathSound() {
			return "mob.zombiepig.zpigdeath";
		}

		public void onStruckByLightning(EntityLightningBolt entityLightningBolt) {
			super.onStruckByLightning(entityLightningBolt);
			int i = (int) this.posX;
			int j = (int) this.posY;
			int k = (int) this.posZ;
			Entity entity = this;

		}

		protected void fall(float l) {
			super.fall(l);
			int i = (int) this.posX;
			int j = (int) this.posY;
			int k = (int) this.posZ;
			super.fall(l);
			Entity entity = this;

		}

		public void onDeath(DamageSource dsource) {
			super.onDeath(dsource);
			int i = (int) this.posX;
			int j = (int) this.posY;
			int k = (int) this.posZ;
			Entity entity = this;

		}

		public void onKillEntity(EntityLiving entityLiving) {
			super.onKillEntity(entityLiving);
			int i = (int) this.posX;
			int j = (int) this.posY;
			int k = (int) this.posZ;
			Entity entity = this;

		}

		public boolean interact(EntityPlayer entity) {
			super.interact(entity);
			int i = (int) this.posX;
			int j = (int) this.posY;
			int k = (int) this.posZ;

			return true;
		}

		public String getEntityName() {
			return "bloodyZombiePigman";
		}

	}

}
