package mod.mcreator;

import net.minecraftforge.common.util.EnumHelper;

import net.minecraft.world.World;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.Item;
import net.minecraft.init.Items;
import net.minecraft.init.Blocks;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.creativetab.CreativeTabs;

import java.util.Random;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.event.FMLServerStartingEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.FMLCommonHandler;
import cpw.mods.fml.client.registry.RenderingRegistry;

public class mcreator_studdedArmor {

	public mcreator_studdedArmor() {
	}

	public static Item helmet;
	public static Item body;
	public static Item legs;
	public static Item boots;
	public Object instance;

	public void load() {
		GameRegistry.addRecipe(new ItemStack(helmet, 1), new Object[]{"XXX", "345", "XXX", Character.valueOf('3'),
				new ItemStack(Blocks.iron_bars, 1), Character.valueOf('4'), new ItemStack(Items.leather_helmet, 1), Character.valueOf('5'),
				new ItemStack(Blocks.iron_bars, 1),});
		GameRegistry.addRecipe(new ItemStack(body, 1), new Object[]{"XXX", "345", "XXX", Character.valueOf('3'), new ItemStack(Blocks.iron_bars, 1),
				Character.valueOf('4'), new ItemStack(Items.leather_chestplate, 1), Character.valueOf('5'), new ItemStack(Blocks.iron_bars, 1),});
		GameRegistry.addRecipe(new ItemStack(legs, 1), new Object[]{"XXX", "345", "XXX", Character.valueOf('3'), new ItemStack(Blocks.iron_bars, 1),
				Character.valueOf('4'), new ItemStack(Items.leather_leggings, 1), Character.valueOf('5'), new ItemStack(Blocks.iron_bars, 1),});
		GameRegistry.addRecipe(new ItemStack(boots, 1), new Object[]{"XXX", "345", "XXX", Character.valueOf('3'), new ItemStack(Blocks.iron_bars, 1),
				Character.valueOf('4'), new ItemStack(Items.leather_boots, 1), Character.valueOf('5'), new ItemStack(Blocks.iron_bars, 1),});
		helmet.setCreativeTab(CreativeTabs.tabCombat);
		body.setCreativeTab(CreativeTabs.tabCombat);
		legs.setCreativeTab(CreativeTabs.tabCombat);
		boots.setCreativeTab(CreativeTabs.tabCombat);
	}

	public void generateNether(World world, Random random, int chunkX, int chunkZ) {
	}

	public void generateSurface(World world, Random random, int chunkX, int chunkZ) {
	}

	public int addFuel(ItemStack fuel) {
		return 0;
	}

	public void serverLoad(FMLServerStartingEvent event) {
	}

	public void preInit(FMLPreInitializationEvent event) {
	}

	public void registerRenderers() {
	}

	static {
		ItemArmor.ArmorMaterial enuma = EnumHelper.addArmorMaterial("STUDDEDARMOR", 15, new int[]{2, 5, 3, 1}, 9);

		int armorPreffix = 0;
		if (FMLCommonHandler.instance().getEffectiveSide() == Side.CLIENT)
			armorPreffix = RenderingRegistry.addNewArmourRendererPrefix("LeatherChain_1.png");
		helmet = (new ItemArmor(enuma, armorPreffix, 0) {
			public void onArmorTick(World world, EntityPlayer entity, ItemStack itemStack) {
				int i = (int) entity.posX;
				int j = (int) entity.posY;
				int k = (int) entity.posZ;
			}
		}).setUnlocalizedName("LeatherChainHelmet").setTextureName("LeatherChainHelmet");
		helmet.setMaxStackSize(1);
		body = (new ItemArmor(enuma, armorPreffix, 1) {
			public void onArmorTick(World world, EntityPlayer entity, ItemStack itemStack) {
				int i = (int) entity.posX;
				int j = (int) entity.posY;
				int k = (int) entity.posZ;
			}
		}).setUnlocalizedName("LeatherChainChestplate").setTextureName("LeatherChainChestplate");
		body.setMaxStackSize(1);
		legs = (new ItemArmor(enuma, armorPreffix, 2) {
			public void onArmorTick(World world, EntityPlayer entity, ItemStack itemStack) {
				int i = (int) entity.posX;
				int j = (int) entity.posY;
				int k = (int) entity.posZ;
			}
		}).setUnlocalizedName("LeatherChainLeggings").setTextureName("LeatherChainLeggings");
		legs.setMaxStackSize(1);
		boots = (new ItemArmor(enuma, armorPreffix, 3) {
			public void onArmorTick(World world, EntityPlayer entity, ItemStack itemStack) {
				int i = (int) entity.posX;
				int j = (int) entity.posY;
				int k = (int) entity.posZ;
			}
		}).setUnlocalizedName("LeatherChainBoots").setTextureName("LeatherChainBoots");
		boots.setMaxStackSize(1);

		Item.itemRegistry.addObject(445, "LeatherChainHelmet", helmet);
		Item.itemRegistry.addObject(446, "LeatherChainChestplate", body);
		Item.itemRegistry.addObject(447, "LeatherChainLeggings", legs);
		Item.itemRegistry.addObject(448, "LeatherChainBoots", boots);

	}

}
